import { select, range, scaleOrdinal } from 'd3';
import { fruitBowl } from './fruitBowl';

const render = dependencies => {
  fruitBowl(select('svg'), dependencies);
}
render.dependencies = `fruits, hoveredIndex, onHover, height`;

const dataflow = Topologica({ render });

const onHover = hoveredIndex => {
  dataflow.set({ hoveredIndex });
};
    
dataflow.set({
  hoveredIndex: null,
  onHover,
  height: +select('svg').attr('height')
});

// Bought 5 apples.
const makeFruit = type => ({ type });
dataflow.set({
  fruits: range(5).map(() => makeFruit('apple'))
});

// Eat an apple.
setTimeout(() => {
  dataflow.set({
    fruits: dataflow.get().fruits.slice(0, -1)
  });
}, 1000);

// Replacing an apple with a lemon.
setTimeout(() => {
  dataflow.set({
    fruits: dataflow.get().fruits.map((d, i) =>
      i === 2 ? { type: 'lemon' } : d
    )
  });
}, 2000);